
/*
 * Camel EndpointConfiguration generated by camel-api-component-maven-plugin
 */
package org.apache.camel.component.box;

import org.apache.camel.spi.Configurer;
import org.apache.camel.spi.UriParam;
import org.apache.camel.spi.UriParams;

/**
 * Camel EndpointConfiguration for org.apache.camel.component.box.api.BoxFilesManager
 */
@UriParams
@Configurer
public final class BoxFilesManagerEndpointConfiguration extends BoxConfiguration {
    @UriParam(description = "The access level of the shared link")
    private com.box.sdk.BoxSharedLink.Access access;
    @UriParam(description = "If the file name is already used, call the uploadNewVersion instead.")
    private Boolean check;
    @UriParam(description = "A stream containing contents of the file to upload")
    private java.io.InputStream content;
    @UriParam(description = "The content created date that will be given to the uploaded file")
    private java.util.Date created;
    @UriParam(description = "The id of the destination folder")
    private String destinationFolderId;
    @UriParam(description = "The information fields to retrieve; if")
    private String[] fields;
    @UriParam(description = "A stream containing contents of the file to upload")
    private java.io.InputStream fileContent;
    @UriParam(description = "The id of file to copy")
    private String fileId;
    @UriParam(description = "The name to give the uploaded file")
    private String fileName;
    @UriParam(description = "The size of the file's content used for monitoring the upload's progress")
    private Long fileSize;
    @UriParam(description = "Either PNG of JPG")
    private com.box.sdk.BoxFile.ThumbnailFileType fileType;
    @UriParam(description = "The updated information")
    private com.box.sdk.BoxFile.Info info;
    @UriParam(description = "A listener for monitoring the download's progress; if")
    private com.box.sdk.ProgressListener listener;
    @UriParam(description = "Maximum height")
    private Integer maxHeight;
    @UriParam(description = "Maximum width")
    private Integer maxWidth;
    @UriParam(description = "The new metadata values")
    private com.box.sdk.Metadata metadata;
    @UriParam(description = "Minimum height")
    private Integer minHeight;
    @UriParam(description = "Minimum width")
    private Integer minWidth;
    @UriParam(description = "The content modified date that will be given to the uploaded file")
    private java.util.Date modified;
    @UriParam(description = "The new name of file")
    private String newFileName;
    @UriParam(description = "Is")
    private String newName;
    @UriParam(description = "The stream to which the file contents will be written")
    private java.io.OutputStream output;
    @UriParam(description = "The id of parent folder")
    private String parentFolderId;
    @UriParam(description = "Is")
    private com.box.sdk.BoxSharedLink.Permissions permissions;
    @UriParam(description = "The byte offset in file at which to stop the download; if")
    private Long rangeEnd;
    @UriParam(description = "The byte offset in file at which to start the download; if")
    private Long rangeStart;
    @UriParam(description = "The size of the file's content used for monitoring the upload's progress.Skip navigation links")
    private Long size;
    @UriParam(description = "The metadata template type name; if")
    private String typeName;
    @UriParam(description = "The date and time at which time the created shared link will expire; if")
    private java.util.Date unshareDate;
    @UriParam(description = "The version of file to delete; initial version of file has value of")
    private Integer version;

    public com.box.sdk.BoxSharedLink.Access getAccess() {
        return access;
    }

    public void setAccess(com.box.sdk.BoxSharedLink.Access access) {
        this.access = access;
    }

    public Boolean getCheck() {
        return check;
    }

    public void setCheck(Boolean check) {
        this.check = check;
    }

    public java.io.InputStream getContent() {
        return content;
    }

    public void setContent(java.io.InputStream content) {
        this.content = content;
    }

    public java.util.Date getCreated() {
        return created;
    }

    public void setCreated(java.util.Date created) {
        this.created = created;
    }

    public String getDestinationFolderId() {
        return destinationFolderId;
    }

    public void setDestinationFolderId(String destinationFolderId) {
        this.destinationFolderId = destinationFolderId;
    }

    public String[] getFields() {
        return fields;
    }

    public void setFields(String[] fields) {
        this.fields = fields;
    }

    public java.io.InputStream getFileContent() {
        return fileContent;
    }

    public void setFileContent(java.io.InputStream fileContent) {
        this.fileContent = fileContent;
    }

    public String getFileId() {
        return fileId;
    }

    public void setFileId(String fileId) {
        this.fileId = fileId;
    }

    public String getFileName() {
        return fileName;
    }

    public void setFileName(String fileName) {
        this.fileName = fileName;
    }

    public Long getFileSize() {
        return fileSize;
    }

    public void setFileSize(Long fileSize) {
        this.fileSize = fileSize;
    }

    public com.box.sdk.BoxFile.ThumbnailFileType getFileType() {
        return fileType;
    }

    public void setFileType(com.box.sdk.BoxFile.ThumbnailFileType fileType) {
        this.fileType = fileType;
    }

    public com.box.sdk.BoxFile.Info getInfo() {
        return info;
    }

    public void setInfo(com.box.sdk.BoxFile.Info info) {
        this.info = info;
    }

    public com.box.sdk.ProgressListener getListener() {
        return listener;
    }

    public void setListener(com.box.sdk.ProgressListener listener) {
        this.listener = listener;
    }

    public Integer getMaxHeight() {
        return maxHeight;
    }

    public void setMaxHeight(Integer maxHeight) {
        this.maxHeight = maxHeight;
    }

    public Integer getMaxWidth() {
        return maxWidth;
    }

    public void setMaxWidth(Integer maxWidth) {
        this.maxWidth = maxWidth;
    }

    public com.box.sdk.Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(com.box.sdk.Metadata metadata) {
        this.metadata = metadata;
    }

    public Integer getMinHeight() {
        return minHeight;
    }

    public void setMinHeight(Integer minHeight) {
        this.minHeight = minHeight;
    }

    public Integer getMinWidth() {
        return minWidth;
    }

    public void setMinWidth(Integer minWidth) {
        this.minWidth = minWidth;
    }

    public java.util.Date getModified() {
        return modified;
    }

    public void setModified(java.util.Date modified) {
        this.modified = modified;
    }

    public String getNewFileName() {
        return newFileName;
    }

    public void setNewFileName(String newFileName) {
        this.newFileName = newFileName;
    }

    public String getNewName() {
        return newName;
    }

    public void setNewName(String newName) {
        this.newName = newName;
    }

    public java.io.OutputStream getOutput() {
        return output;
    }

    public void setOutput(java.io.OutputStream output) {
        this.output = output;
    }

    public String getParentFolderId() {
        return parentFolderId;
    }

    public void setParentFolderId(String parentFolderId) {
        this.parentFolderId = parentFolderId;
    }

    public com.box.sdk.BoxSharedLink.Permissions getPermissions() {
        return permissions;
    }

    public void setPermissions(com.box.sdk.BoxSharedLink.Permissions permissions) {
        this.permissions = permissions;
    }

    public Long getRangeEnd() {
        return rangeEnd;
    }

    public void setRangeEnd(Long rangeEnd) {
        this.rangeEnd = rangeEnd;
    }

    public Long getRangeStart() {
        return rangeStart;
    }

    public void setRangeStart(Long rangeStart) {
        this.rangeStart = rangeStart;
    }

    public Long getSize() {
        return size;
    }

    public void setSize(Long size) {
        this.size = size;
    }

    public String getTypeName() {
        return typeName;
    }

    public void setTypeName(String typeName) {
        this.typeName = typeName;
    }

    public java.util.Date getUnshareDate() {
        return unshareDate;
    }

    public void setUnshareDate(java.util.Date unshareDate) {
        this.unshareDate = unshareDate;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }
}
